//DechainerBlocs_501f.js
// 08.06.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Dechane les blocs

//Credits: inspir de "SplitStory.jsx" (an InDesign CS5 JavaScript)

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// la slection 
var appSel = app.selection;
var nSel   = appSel.length;
if (nSel  == 0) {
	alert ("Il n'y a pas de slection.", "Stop");
	exit();
}

// prparer une liste
var storyIDs = new Array ();
// une boucle  travers la slection
for (var s=0; s<nSel; s++) {
	// l'lment actuel de la slection
	curSel = appSel[s];
	// tester si les conditions sont remplies
	if (curSel.hasOwnProperty("baseline") || curSel.constructor.name == "TextFrame") {
		// le numro ID de la chane actuelle
		var curID = curSel.parentStory.id;
		// appeler la fonction qui vrifie le numro
		if (!checkID(storyIDs, curID)) {
			// l'ajouter  la liste si celle-ci ne le contient pas encore
			storyIDs.push(curID);
		}
	}
}

// le nombre de numros ID
var nIDs = storyIDs.length;
if (nIDs == 0) {
	alert ("Il n'y a pas de chane slectionne.", "Attention");
	exit();
} 

// initialiser une variable compteur
var sCtr = 0;
// une boucle  travers les chanes de texte
for (var i=0; i<nIDs; i++) {
	curID = storyIDs[i];
	var curStory = curDoc.stories.itemByID(curID);
	// la chane doit passer d'un bloc  un autre
	if (curStory.textContainers.length > 1) {
		// appeler la fonction qui duplique les blocs
		splitStory(curStory);
		// appeler la fonction qui supprime les blocs d'origine
		removeFrames(curStory);
		sCtr++;
	}
}

// annoncer la fin de l'action
if (sCtr > 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Termin.");
	dlog.show();
	// une petite pause
	$.sleep(999);
	// fermer la fentre
	dlog.close();
}
else {
	alert ("La chane doit passer au moins d'un bloc  un autre.", "Attention");
}

// les fonctions /////////////////////////////////////////////////////////////////////////////////

// tester si le numro ID se trouve dj dans la liste
function checkID(storyIDs, curID) {
	for (var i=0; i<storyIDs.length; i++) {
		if (storyIDs[i] == curID) {
			return true;
		}
	}
	return false;
}

// dupliquer les blocs texte
function splitStory(curStory) {
	// la boucle tourne  l'envers
	for(var ctr=curStory.textContainers.length-1; ctr>-1; ctr--){
		curStory.textContainers[ctr].duplicate();
	}
}

// supprimer les blocs d'origine
function removeFrames(curStory) {
	//visiter les blocs 
	for (var ctr=curStory.textContainers.length-1; ctr>-1; ctr--) {
		// le bloc texte actuel...
		var curFrame = curStory.textContainers[ctr];
		try {
			// ... est dverrouill...
			curFrame.locked = false;
			// ... et supprim
			curFrame.remove();
		}
		catch (e) {
		}
	}
}